diff -urN qmail-1.03-vanilla/qmail-remote.c qmail-1.03-md24/qmail-remote.c
--- qmail-1.03-vanilla/qmail-remote.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-remote.c	2007-07-19 23:01:53.000000000 +0200
@@ -1,7 +1,16 @@
+/*
+ * - esmtp size + auth + logging by me: http://www.mcmilk.de/qmail/
+ * - many other improvements
+ */
+
 #include <sys/types.h>
 #include <sys/socket.h>
+#include <sys/stat.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
+#include <unistd.h>
+#include <string.h>
+
 #include "sig.h"
 #include "stralloc.h"
 #include "substdio.h"
@@ -11,6 +20,7 @@
 #include "error.h"
 #include "auto_qmail.h"
 #include "control.h"
+#include "base64.h"
 #include "dns.h"
 #include "alloc.h"
 #include "quote.h"
@@ -19,7 +29,9 @@
 #include "ipme.h"
 #include "gen_alloc.h"
 #include "gen_allocdefs.h"
+#include "fmt.h"
 #include "str.h"
+#include "hmac.h"
 #include "now.h"
 #include "exit.h"
 #include "constmap.h"
@@ -30,61 +42,155 @@
 #include "timeoutwrite.h"
 
 #define HUGESMTPTEXT 5000
+unsigned long smtp_port = 25;
+unsigned long qmtp_port = 209;
 
-#define PORT_SMTP 25 /* silly rabbit, /etc/services is for users */
-unsigned long port = PORT_SMTP;
+char *name="qmail-remote";
+int ctl_log_fd=25; /* logging fd if >0 */
 
 GEN_ALLOC_typedef(saa,stralloc,sa,len,a)
 GEN_ALLOC_readyplus(saa,stralloc,sa,len,a,i,n,x,10,saa_readyplus)
 static stralloc sauninit = {0};
 
+substdio ssin;
+substdio smtpto;
+substdio smtpfrom;
+
+struct constmap maproutes;
+struct constmap maprelays;
+struct constmap mapqroutes;
+
+stralloc outgoingip = {0};
 stralloc helohost = {0};
+stralloc qroutes = {0};
 stralloc routes = {0};
-struct constmap maproutes;
-stralloc host = {0};
+stralloc relays = {0};
 stralloc sender = {0};
+stralloc host = {0};
 
-saa reciplist = {0};
+stralloc authuser = {0};
+stralloc authpass = {0};
+stralloc authtype = {0};
+stralloc slop = {0};
+stralloc resp = {0};
+stralloc temp = {0};
+
+saa reciplist = {0};  /* list of recipients */
+saa ehlokw = {0};     /* list of EHLO keywords and parameters */
 
 struct ip_address partner;
+struct ip_address outip;
+
+/* auth stuff */
+unsigned char digest[21], encrypted[41];
+char hextab[]="0123456789abcdef";
+char *sasl[] = { "LOGIN","PLAIN","CRAM-MD5","CRAM-SHA1","CRAM-RIPEMD","DIGEST-MD5" };
+#define SASL_MAX 6
+int ehloflags = 0; /* */
+int authflags = 0; /* possible auth types, which are suported by client+server */
+int needauth = 0;  /* is set, when we have to authenticate */
+
+int client_auth_login(char *arg);
+int client_auth_plain(char *arg);
+int client_auth_cram_md5(char *arg);
+int client_auth_cram_rmd(char *arg);
+int client_auth_cram_sha1(char *arg);
+int client_auth_digest_md5(char *arg);
+int client_auth_notsupported(char *arg);
+
+typedef struct {
+  char *text;
+  int  (*fun)();
+} authcmd_t;
+
+authcmd_t authcmds[] = {
+  { "login",       client_auth_login }
+, { "plain",       client_auth_plain }
+, { "cram-md5",    client_auth_cram_md5 }
+, { "cram-ripemd", client_auth_cram_rmd }
+, { "cram-sha1",   client_auth_cram_sha1 }
+/* , { "digest-md5",  client_auth_digest_md5 } */
+, { 0,             client_auth_notsupported }
+};
+
+void quit(char *prepend, char *append);
+
+/* flush all buffers */
+void flush(void)
+{
+  substdio_flush(&smtpto);
+  substdio_flush(subfdoutsmall);
+  if (ctl_log_fd) substdio_flush(subfderr);
+}
 
-void out(s) char *s; { if (substdio_puts(subfdoutsmall,s) == -1) _exit(0); }
-void zero() { if (substdio_put(subfdoutsmall,"\0",1) == -1) _exit(0); }
-void zerodie() { zero(); substdio_flush(subfdoutsmall); _exit(0); }
-void outsafe(sa) stralloc *sa; { int i; char ch;
-for (i = 0;i < sa->len;++i) {
-ch = sa->s[i]; if (ch < 33) ch = '?'; if (ch > 126) ch = '?';
-if (substdio_put(subfdoutsmall,&ch,1) == -1) _exit(0); } }
-
-void temp_nomem() { out("ZOut of memory. (#4.3.0)\n"); zerodie(); }
-void temp_oserr() { out("Z\
-System resources temporarily unavailable. (#4.3.0)\n"); zerodie(); }
-void temp_noconn() { out("Z\
-Sorry, I wasn't able to establish an SMTP connection. (#4.4.1)\n"); zerodie(); }
-void temp_read() { out("ZUnable to read message. (#4.3.0)\n"); zerodie(); }
-void temp_dnscanon() { out("Z\
-CNAME lookup failed temporarily. (#4.4.3)\n"); zerodie(); }
-void temp_dns() { out("Z\
-Sorry, I couldn't find any host by that name. (#4.1.2)\n"); zerodie(); }
-void temp_chdir() { out("Z\
-Unable to switch to home directory. (#4.3.0)\n"); zerodie(); }
-void temp_control() { out("Z\
-Unable to read control files. (#4.3.0)\n"); zerodie(); }
-void perm_partialline() { out("D\
-SMTP cannot transfer messages with partial final lines. (#5.6.2)\n"); zerodie(); }
-void perm_usage() { out("D\
-I (qmail-remote) was invoked improperly. (#5.3.5)\n"); zerodie(); }
-void perm_dns() { out("D\
-Sorry, I couldn't find any host named ");
-outsafe(&host);
-out(". (#5.1.2)\n"); zerodie(); }
-void perm_nomx() { out("D\
-Sorry, I couldn't find a mail exchanger or IP address. (#5.4.4)\n");
-zerodie(); }
-void perm_ambigmx() { out("D\
-Sorry. Although I'm listed as a best-preference MX or A for that host,\n\
-it isn't in my control/locals file, so I don't treat it as local. (#5.4.6)\n");
-zerodie(); }
+void Logn(char *s, int n)
+{
+  if (ctl_log_fd)
+    if (substdio_put(subfderr,s,n) == -1) _exit(0);
+
+  return;
+}
+
+void Log(char *s)
+{
+  if (ctl_log_fd)
+    if (substdio_puts(subfderr,s) == -1) _exit(0);
+
+  return;
+}
+
+void smtp_to(char *s)
+{ if (substdio_puts(&smtpto,s) == -1) _exit(0); Log(s); }
+
+void smtp_nto(char *s, int n)
+{ if (substdio_put(&smtpto,s,n) == -1) _exit(0); Logn(s,n); }
+
+void smtp_eol(void)
+{
+  if (substdio_puts(subfderr, "\n") == -1) _exit(0);
+  if (substdio_puts(&smtpto, "\r\n") == -1) _exit(0);
+  flush();
+}
+
+void out(char *s)
+{
+  if (substdio_puts(subfdoutsmall,s) == -1) _exit(0);
+}
+
+void zero()
+{
+  if (substdio_put(subfdoutsmall,"\0",1) == -1) _exit(0);
+}
+
+void zerodie() { zero(); flush(); _exit(0); }
+
+void outsafe(stralloc *sa)
+{
+  int i; char ch;
+  for (i = 0;i < sa->len;++i) {
+    ch = sa->s[i]; if (ch < 33) ch = '?';
+    if (ch > 126) ch = '?';
+    if (substdio_put(subfdoutsmall,&ch,1) == -1) _exit(0);
+  }
+}
+
+void temp_noip()    { out("Z4.3.0 invalid ipaddr in control/outgoingip\n"); zerodie(); }
+void temp_nomem()   { out("Z4.3.0 Out of memory.\n"); zerodie(); }
+void temp_oserr()   { out("Z4.3.0 System resources temporarily unavailable.\n"); zerodie(); }
+void temp_noconn()  { out("Z4.4.1 Sorry, I wasn't able to establish an SMTP connection.\n"); zerodie(); }
+void temp_read()    { out("Z4.3.0 Unable to read message.\n"); zerodie(); }
+void temp_dnscanon(){ out("Z4.4.3 CNAME lookup failed temporarily.\n"); zerodie(); }
+void temp_dns()     { out("Z4.1.2 Sorry, I couldn't find any host by that name.\n"); zerodie(); }
+void temp_chdir()   { out("Z4.3.0 Unable to switch to home directory.\n"); zerodie(); }
+void temp_control() { out("Z4.3.0 Unable to read control files.\n"); zerodie(); }
+void temp_proto()   { out("Z4.3.0 recipient did not talk proper QMTP\n"); zerodie(); }
+
+void perm_pl()      { out("D5.6.2 SMTP cannot transfer messages with partial final lines.\n"); zerodie(); }
+void perm_usage()   { out("D5.3.5 I (qmail-remote) was invoked improperly.\n"); zerodie(); }
+void perm_dns()     { out("D5.1.2 Sorry, I couldn't find any host named ");outsafe(&host);out(".\n"); zerodie(); }
+void perm_nomx()    { out("D5.4.4 Sorry, I couldn't find a mail exchanger or IP address.\n"); zerodie(); }
+void perm_ambigmx() { out("D5.4.6 Sorry. Although I'm listed as a best-preference MX or A for that host,\n"
+                              "it isn't in my control/locals file, so I don't treat it as local.\n"); zerodie(); }
 
 void outhost()
 {
@@ -93,20 +199,17 @@
 }
 
 int flagcritical = 0;
+int timeoutconnect = 60;
+int smtpfd;
+int timeout = 1200;
 
 void dropped() {
-  out("ZConnected to ");
-  outhost();
-  out(" but connection died. ");
+  out("Z4.4.2 Connected to "); outhost(); out(" but connection died. ");
   if (flagcritical) out("Possible duplicate! ");
-  out("(#4.4.2)\n");
+  out("\n");
   zerodie();
 }
 
-int timeoutconnect = 60;
-int smtpfd;
-int timeout = 1200;
-
 int saferead(fd,buf,len) int fd; char *buf; int len;
 {
   int r;
@@ -114,6 +217,7 @@
   if (r <= 0) dropped();
   return r;
 }
+
 int safewrite(fd,buf,len) int fd; char *buf; int len;
 {
   int r;
@@ -122,24 +226,44 @@
   return r;
 }
 
-char inbuf[1024];
-substdio ssin = SUBSTDIO_FDBUF(read,0,inbuf,sizeof inbuf);
-char smtptobuf[1024];
-substdio smtpto = SUBSTDIO_FDBUF(safewrite,-1,smtptobuf,sizeof smtptobuf);
-char smtpfrombuf[128];
+char inbuf[1624];
+char smtptobuf[1624];  /* out */
+char smtpfrombuf[1624]; /* in */
+
+substdio ssin     = SUBSTDIO_FDBUF(read,0,inbuf,sizeof inbuf);
+substdio smtpto   = SUBSTDIO_FDBUF(safewrite,-1,smtptobuf,sizeof smtptobuf);
 substdio smtpfrom = SUBSTDIO_FDBUF(saferead,-1,smtpfrombuf,sizeof smtpfrombuf);
 
 stralloc smtptext = {0};
 
-void get(ch)
-char *ch;
+void get(char *ch)
 {
   substdio_get(&smtpfrom,ch,1);
-  if (*ch != '\r')
-    if (smtptext.len < HUGESMTPTEXT)
-     if (!stralloc_append(&smtptext,ch)) temp_nomem();
+  if (*ch != '\r') {
+    if (smtptext.len < HUGESMTPTEXT) {
+      if (!stralloc_append(&smtptext,ch)) temp_nomem();
+      Logn(ch, 1);
+    }
+  }
+
+  return;
 }
 
+void doname(void)
+{
+  static int pid=0;
+  char pidstr[FMT_ULONG];
+
+  if (!pid) { pid=getpid(); }
+  pidstr[fmt_ulong(pidstr,pid)] = 0;
+  Log(name);Log(": pid ");Log(pidstr);Log(" ");
+
+  return;
+}
+
+void client(void) { doname(); Log("S: "); }
+void doserv(void) { doname(); Log("C: "); }
+
 unsigned long smtpcode()
 {
   unsigned char ch;
@@ -147,6 +271,7 @@
 
   if (!stralloc_copys(&smtptext,"")) temp_nomem();
 
+  client();
   get(&ch); code = ch - '0';
   get(&ch); code = code * 10 + (ch - '0');
   get(&ch); code = code * 10 + (ch - '0');
@@ -154,18 +279,189 @@
     get(&ch);
     if (ch != '-') break;
     while (ch != '\n') get(&ch);
-    get(&ch);
-    get(&ch);
-    get(&ch);
+    client();
+    get(&ch); get(&ch); get(&ch);
   }
   while (ch != '\n') get(&ch);
+  flush();
 
   return code;
 }
 
+#define ERR_AUTH_FAILED 1
+#define ERR_AUTH_INPUT  2
+#define ERR_AUTH_ABORT  3
+
+/* AUTH LOGIN with long form */
+int client_auth_login(char *arg)
+{
+  doserv(); smtp_to("AUTH LOGIN"); smtp_eol();
+  if (smtpcode() != 334) return ERR_AUTH_FAILED;
+
+  if (!stralloc_copy(&slop, &authuser)) temp_nomem();
+  if (b64encode(&temp, &slop) != 0) return ERR_AUTH_INPUT;
+  doserv(); smtp_nto(temp.s, temp.len); smtp_eol();
+  if (smtpcode() != 334) return ERR_AUTH_FAILED;
+
+  if (!stralloc_copy(&slop, &authpass)) temp_nomem();
+  if (b64encode(&temp, &slop) != 0) return ERR_AUTH_INPUT;
+  doserv(); smtp_nto(temp.s, temp.len); smtp_eol();
+  if (smtpcode() != 235) return ERR_AUTH_FAILED;
+
+  return 0;
+}
+
+/* AUTH PLAIN in short form */
+int client_auth_plain(char *arg)
+{
+  if (!stralloc_0(&slop)) temp_nomem();
+  if (!stralloc_cat(&slop, &authuser)) temp_nomem();
+  if (!stralloc_0(&slop)) temp_nomem();
+  if (!stralloc_cat(&slop, &authpass)) temp_nomem();
+  if (b64encode(&temp, &slop) != 0) return ERR_AUTH_INPUT;
+
+  doserv(); smtp_to("AUTH PLAIN "); smtp_nto(temp.s, temp.len); smtp_eol();
+  if (smtpcode() != 235) return ERR_AUTH_FAILED;
+
+  return 0;
+}
+
+int client_auth_cram_md5(char *arg)
+{
+  unsigned int code;
+  unsigned char *e=encrypted;
+  int i;
+
+  doserv(); smtp_to("AUTH CRAM-MD5"); smtp_eol();
+  code = smtpcode();
+  if (code != 334) return ERR_AUTH_FAILED;
+  if (b64decode(&resp, smtptext.s+4, smtptext.len-5) != 0)
+    return ERR_AUTH_INPUT;
+  resp.s[resp.len]=0;
+
+  hmac_md5(resp.s, authpass.s, digest);
+  for (i=0; i<16; i++) {
+    *e = hextab[digest[i]/16]; ++e;
+    *e = hextab[digest[i]%16]; ++e;
+  } *e=0;
+
+  if (!stralloc_copy(&slop, &authuser)) temp_nomem();
+  if (!stralloc_cats(&slop, " ")) temp_nomem();
+  if (!stralloc_cats(&slop, encrypted)) temp_nomem();
+  if (b64encode(&temp, &slop) != 0) return ERR_AUTH_INPUT;
+
+  doserv(); smtp_nto(temp.s, temp.len); smtp_eol();
+  code = smtpcode();
+  if (code != 235) return ERR_AUTH_FAILED;
+
+  return 0;
+}
+
+int client_auth_cram_sha1(char *arg)
+{
+  unsigned int code;
+  unsigned char *e=encrypted;
+  int i;
+
+  doserv(); smtp_to("AUTH CRAM-SHA1"); smtp_eol();
+  code = smtpcode();
+  if (code != 334) return ERR_AUTH_FAILED;
+  if (b64decode(&resp, smtptext.s+4, smtptext.len-5) != 0)
+    return ERR_AUTH_INPUT;
+  resp.s[resp.len]=0;
+
+  hmac_sha1(resp.s, authpass.s, digest);
+  for (i=0; i<20; i++) {
+    *e = hextab[digest[i]/16]; ++e;
+    *e = hextab[digest[i]%16]; ++e;
+  } *e=0;
+
+  if (!stralloc_copy(&slop, &authuser)) temp_nomem();
+  if (!stralloc_cats(&slop, " ")) temp_nomem();
+  if (!stralloc_cats(&slop, encrypted)) temp_nomem();
+  if (b64encode(&temp, &slop) != 0) return ERR_AUTH_INPUT;
+
+  doserv(); smtp_nto(temp.s, temp.len); smtp_eol();
+  code = smtpcode();
+  if (code != 235) return ERR_AUTH_FAILED;
+
+  return 0;
+}
+
+int client_auth_cram_rmd(char *arg)
+{
+  unsigned int code;
+  unsigned char *e=encrypted;
+  int i;
+
+  doserv(); smtp_to("AUTH CRAM-RIPEMD"); smtp_eol();
+  code = smtpcode();
+  if (code != 334) return ERR_AUTH_FAILED;
+  if (b64decode(&resp, smtptext.s+4, smtptext.len-5) != 0)
+    return ERR_AUTH_INPUT;
+  resp.s[resp.len]=0;
+
+  hmac_ripemd(resp.s, authpass.s, digest);
+  for (i=0; i<20; i++) {
+    *e = hextab[digest[i]/16]; ++e;
+    *e = hextab[digest[i]%16]; ++e;
+  } *e=0;
+
+  if (!stralloc_copy(&slop, &authuser)) temp_nomem();
+  if (!stralloc_cats(&slop, " ")) temp_nomem();
+  if (!stralloc_cats(&slop, encrypted)) temp_nomem();
+  if (b64encode(&temp, &slop) != 0) return ERR_AUTH_INPUT;
+
+  doserv(); smtp_nto(temp.s, temp.len); smtp_eol();
+  code = smtpcode();
+  if (code != 235) return ERR_AUTH_FAILED;
+
+  return 0;
+}
+
+/* XXX */
+int client_auth_digest_md5(char *arg)
+{
+  unsigned int code;
+
+  doserv(); smtp_to("AUTH DIGEST-MD5"); smtp_eol();
+  code = smtpcode();
+  return 0;
+}
+
+int client_auth_notsupported(char *arg)
+{
+  quit("DConnected to "," but can't do authentication with of that type!");
+  return 1;
+}
+
+void doauth(char *arg)
+{
+  int i;
+
+//  doname(); Log("trying auth with: "); Log(arg); Log(" ...\n"); flush();
+  for (i=0; authcmds[i].text; ++i)
+    if (case_equals(authcmds[i].text, arg)) break;
+  if (!stralloc_copys(&resp, "")) temp_nomem();
+  if (!stralloc_copys(&slop, "")) temp_nomem();
+  if (!stralloc_copys(&temp, "")) temp_nomem();
+  switch (authcmds[i].fun(arg)) {
+    case 0: return;
+    case ERR_AUTH_INPUT:
+      quit("DConnected to "," but we got incorrect authentication input!");
+      break;
+    case ERR_AUTH_FAILED:
+      quit("DConnected to "," but authentication failed!");
+      break;
+    case ERR_AUTH_ABORT:
+      quit("DConnected to "," but aborted!");
+      break;
+  }
+}
+
 void outsmtptext()
 {
-  int i; 
+  int i;
   if (smtptext.s) if (smtptext.len) {
     out("Remote host said: ");
     for (i = 0;i < smtptext.len;++i)
@@ -175,16 +471,16 @@
   }
 }
 
-void quit(prepend,append)
-char *prepend;
-char *append;
+void quit(char *prepend, char *append)
 {
-  substdio_putsflush(&smtpto,"QUIT\r\n");
-  /* waiting for remote side is just too ridiculous */
+  doserv();
+  smtp_to("QUIT");
   out(prepend);
   outhost();
   out(append);
   out(".\n");
+  smtp_eol();
+
   outsmtptext();
   zerodie();
 }
@@ -203,47 +499,165 @@
     while (ch != '\n') {
       substdio_put(&smtpto,&ch,1);
       r = substdio_get(&ssin,&ch,1);
-      if (r == 0) perm_partialline();
+      if (r == 0) perm_pl();
       if (r == -1) temp_read();
     }
     substdio_put(&smtpto,"\r\n",2);
   }
- 
+
   flagcritical = 1;
   substdio_put(&smtpto,".\r\n",3);
-  substdio_flush(&smtpto);
+  doserv(); Log("[...]\n"); flush();
 }
 
-stralloc recip = {0};
+char *partner_fqdn = 0;
 
-void smtp()
+#define F_EHLO_AUTH  0x01
+#define F_EHLO_SIZE  0x02
+int maxehlokwlen=0;
+unsigned long ehlo()
 {
+  stralloc *sa;
+  char *s, *e, *p;
   unsigned long code;
-  int flagbother;
-  int i;
- 
-  if (smtpcode() != 220) quit("ZConnected to "," but greeting failed");
- 
-  substdio_puts(&smtpto,"HELO ");
-  substdio_put(&smtpto,helohost.s,helohost.len);
-  substdio_puts(&smtpto,"\r\n");
-  substdio_flush(&smtpto);
-  if (smtpcode() != 250) quit("ZConnected to "," but my name was rejected");
- 
-  substdio_puts(&smtpto,"MAIL FROM:<");
-  substdio_put(&smtpto,sender.s,sender.len);
-  substdio_puts(&smtpto,">\r\n");
-  substdio_flush(&smtpto);
+
+  if (ehlokw.len > maxehlokwlen) maxehlokwlen = ehlokw.len;
+  ehlokw.len = 0;
+
+  doserv();
+  smtp_to("EHLO ");
+  smtp_nto(helohost.s, helohost.len);
+  smtp_eol();
+
+  code = smtpcode();
+  if (code != 250) return code;
+
+  s = smtptext.s;
+  while (*s++ != '\n') ; /* skip the first line: contains the domain */
+
+  e = smtptext.s + smtptext.len - 6; /* 250-?\n */
+  while (s <= e)
+  {
+    if (!saa_readyplus(&ehlokw, 1)) temp_nomem();
+    sa = ehlokw.sa + ehlokw.len++;
+    if (ehlokw.len > maxehlokwlen) *sa = sauninit; else sa->len = 0;
+
+    /* smtptext is known to end in a '\n' */
+    for (p = (s += 4); ; ++p)
+      if (*p == '\n' || *p == ' ' || *p == '\t') {
+        if (!stralloc_catb(sa, s, p - s) || !stralloc_0(sa)) temp_nomem();
+        if (*p++ == '\n') break;
+        while (*p == ' ' || *p == '\t') p++;
+        s = p;
+      }
+    s = p;
+    /* keyword should consist of alpha-num and '-'
+     * broken AUTH might use '=' instead of space */
+    for (p = sa->s; *p; ++p) if (*p == '=') { *p = 0; break; }
+  }
+
+  return 250;
+}
+
+void smtp(char *size)
+{
+  unsigned long code=0;
+  int flagbother, i;
+
+  code = smtpcode();
+  if (code >= 400 && code < 600) return; /* try next MX, see RFC-2821 */
+  if (code != 220) quit("ZConnected to "," but greeting failed");
+
+  //doname(); Log("stelle1"); Log("\n"); flush();
+  code = ehlo();
+  if (code == 250) {
+    if (ehlokw.len)
+    for (i=0; i<ehlokw.len; i++) {
+      char *x=ehlokw.sa[i].s;
+      char f[FMT_ULONG];
+      f[fmt_ulong(f, ehlokw.len)]=0;
+      ehlokw.sa[i].s[ehlokw.sa[i].len]=0;
+      //doname(); Log("stelle2"); Log("\n"); flush();
+      //doname(); Log("ehlokw.len="); Log(f); Log("\n"); flush();
+      switch (strlen(x)) {
+      case 4:
+	/* does the server support ESMTP AUTH? */
+        if (case_equals(x, "AUTH")) {
+	  ehloflags |= F_EHLO_AUTH;
+	  /* scan for possible auth types */
+	  while (x += strlen(x)+1) {
+	    int j;
+	    for (j = 0; authcmds[j].text; ++j) {
+              if (case_equals(authcmds[j].text, x)) {
+	        authflags |= 1<<j; break;
+	      }
+	    }
+	    if (x - ehlokw.sa[i].s >= ehlokw.sa[i].len) break;
+	  }
+	  break;
+	}
+	/* does the server support ESMTP SIZE? */
+        if (case_equals(x, "SIZE")) ehloflags |= F_EHLO_SIZE;
+        break;
+      }
+    }
+  } else {
+    /* EHLO failed, we will try it with HELO */
+    doserv();
+    smtp_to("HELO ");
+    smtp_nto(helohost.s, helohost.len);
+    smtp_eol();
+    if (smtpcode() != 250) quit("ZConnected to "," but my name was rejected");
+  }
+
+  //doname(); Log("stelle3"); Log("\n"); flush();
+
+  /* if needed, we authenticate now */
+  if (needauth) {
+    if (authtype.len) {
+      /* smtprelays gives us a mechanism */
+      authtype.s[authtype.len]=0; doauth(authtype.s);
+    } else if (ehloflags & F_EHLO_AUTH) {
+      for (i=SASL_MAX; i>=0; i--) {
+        if ((authflags & 1<<i) == 1<<i) {
+          doauth(sasl[i]); break;
+        }
+      }
+    } else {
+      /* - server does not support EHLO
+       * - take authtype from smtprelays or NOTHING!
+       */
+      if (!authtype.len) {
+        quit("DConnected to "," but can't do required authentication / give me a hint in control/smtprelays!");
+      }
+      authtype.s[authtype.len]=0; doauth(authtype.s);
+    }
+  }
+
+  //doname(); Log("stelle4"); Log("\n"); flush();
+
+  doserv();
+  smtp_to("MAIL FROM:<");
+  smtp_nto(sender.s,sender.len);
+  smtp_to(">");
+  if (ehloflags & F_EHLO_SIZE) {
+    smtp_to(" SIZE=");
+    smtp_to(size);
+  }
+  smtp_eol();
+
   code = smtpcode();
   if (code >= 500) quit("DConnected to "," but sender was rejected");
   if (code >= 400) quit("ZConnected to "," but sender was rejected");
- 
+
   flagbother = 0;
   for (i = 0;i < reciplist.len;++i) {
-    substdio_puts(&smtpto,"RCPT TO:<");
-    substdio_put(&smtpto,reciplist.sa[i].s,reciplist.sa[i].len);
-    substdio_puts(&smtpto,">\r\n");
-    substdio_flush(&smtpto);
+    doserv();
+    smtp_to("RCPT TO:<");
+    smtp_nto(reciplist.sa[i].s, reciplist.sa[i].len);
+    smtp_to(">");
+    smtp_eol();
+
     code = smtpcode();
     if (code >= 500) {
       out("h"); outhost(); out(" does not like recipient.\n");
@@ -259,33 +673,142 @@
     }
   }
   if (!flagbother) quit("DGiving up on ","");
- 
-  substdio_putsflush(&smtpto,"DATA\r\n");
+
+  doserv();
+  smtp_to("DATA");
+  smtp_eol();
+
   code = smtpcode();
   if (code >= 500) quit("D"," failed on DATA command");
   if (code >= 400) quit("Z"," failed on DATA command");
- 
+
   blast();
   code = smtpcode();
+
   flagcritical = 0;
   if (code >= 500) quit("D"," failed after I sent the message");
   if (code >= 400) quit("Z"," failed after I sent the message");
   quit("K"," accepted message");
 }
 
+int qmtp_priority(int pref)
+{
+  if (pref < 12800) return 0;
+  if (pref > 13055) return 0;
+  if (pref % 16 == 1) return 1;
+  return 0;
+}
+
+void qmtp()
+{
+  struct stat st;
+  unsigned long len;
+  char *x;
+  int i, n;
+  unsigned char ch;
+  char num[FMT_ULONG];
+  int flagallok;
+
+  if (fstat(0,&st) == -1) quit("Z", " unable to fstat stdin");
+  len = st.st_size;
+
+  num[fmt_ulong(num,len+1)]=0;
+  doserv();
+  smtp_to(num);
+  smtp_to(":\n");
+  while (len > 0) {
+    n = substdio_feed(&ssin);
+    if (n <= 0) _exit(32); /* wise guy again */
+    x = substdio_PEEK(&ssin);
+    smtp_nto(x,n);
+    substdio_SEEK(&ssin,n);
+    len -= n;
+  }
+  smtp_to(",");
+
+  len = sender.len;
+  num[fmt_ulong(num,len)]=0;
+  smtp_to(num);
+  smtp_to(":");
+  smtp_nto(sender.s,sender.len);
+  smtp_to(",");
+
+  len = 0;
+  for (i = 0;i < reciplist.len;++i)
+    len += fmt_ulong(num,reciplist.sa[i].len) + 1 + reciplist.sa[i].len + 1;
+    num[fmt_ulong(num,len)]=0;
+    smtp_to(num);
+    smtp_to(":");
+  for (i = 0;i < reciplist.len;++i) {
+      num[fmt_ulong(num,reciplist.sa[i].len)]=0;
+      smtp_to(num);
+      smtp_to(":");
+      smtp_nto(reciplist.sa[i].s,reciplist.sa[i].len);
+      smtp_to(",");
+  }
+  smtp_to(",");
+  flush();
+
+  flagallok = 1;
+
+  for (i = 0;i < reciplist.len;++i) {
+    len = 0;
+    for (;;) {
+      get(&ch);
+      if (ch == ':') break;
+      if (len > 200000000) temp_proto();
+      if (ch - '0' > 9) temp_proto();
+      len = 10 * len + (ch - '0');
+    }
+    if (!len) temp_proto();
+    get(&ch); --len;
+    if ((ch != 'Z') && (ch != 'D') && (ch != 'K')) temp_proto();
+
+    if (!stralloc_copyb(&smtptext,&ch,1)) temp_proto();
+    if (!stralloc_cats(&smtptext,"qmtp: ")) temp_nomem();
+
+    while (len > 0) { get(&ch); --len; }
+
+    for (len = 0;len < smtptext.len;++len) {
+      ch = smtptext.s[len];
+      if ((ch < 32) || (ch > 126)) smtptext.s[len] = '?';
+    }
+    get(&ch);
+    if (ch != ',') temp_proto();
+    smtptext.s[smtptext.len-1] = '\n';
+
+    if (smtptext.s[0] == 'K') out("r");
+    else if (smtptext.s[0] == 'D') {
+      out("h");
+      flagallok = 0;
+    } else {
+      out("s");
+      flagallok = 0;
+    }
+    smtp_nto(smtptext.s+1, smtptext.len-1);
+    zero();
+  }
+  if (!flagallok) {
+    out("DGiving up on ");outhost();out("\n");
+  } else {
+    out("KAll received okay by ");outhost();out("\n");
+  }
+  zerodie();
+}
+
 stralloc canonhost = {0};
 stralloc canonbox = {0};
 
 void addrmangle(saout,s,flagalias,flagcname)
-stralloc *saout; /* host has to be canonical, box has to be quoted */
-char *s;
-int *flagalias;
-int flagcname;
+  stralloc *saout; /* host has to be canonical, box has to be quoted */
+  char *s;
+  int *flagalias;
+  int flagcname;
 {
   int j;
- 
+
   *flagalias = flagcname;
- 
+
   j = str_rchr(s,'@');
   if (!s[j]) {
     if (!stralloc_copys(saout,s)) temp_nomem();
@@ -295,12 +818,12 @@
   canonbox.len = j;
   if (!quote(saout,&canonbox)) temp_nomem();
   if (!stralloc_cats(saout,"@")) temp_nomem();
- 
+
   if (!stralloc_copys(&canonhost,s + j + 1)) temp_nomem();
   if (flagcname)
     switch(dns_cname(&canonhost)) {
       case 0: *flagalias = 0; break;
-      case DNS_MEM: temp_nomem();
+      case DNS_MEM:  temp_nomem();
       case DNS_SOFT: temp_dnscanon();
       case DNS_HARD: ; /* alias loop, not our problem */
     }
